package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.CicloFlows;
import com.javaseleniumtemplate.pages.CicloPage;
import org.testng.annotations.Test;

public class CicloTests extends TestBase {

    CicloPage cicloPage;
    CicloFlows cicloFlows;
    LoginFlows loginFlows;

    //adicionar um novo ciclo
    //verificar código, nome, número de semanas e cardápios, início do ciclo adicionado
    //editar o nome do ciclo
    //adicionar padão de ciclo com tipos de prato
    //ativar uma opção dos tipos de prato
    //adicionar, editar e apagar um complemento
    //excluir os tipos de prato
    //excluir o ciclo adicionado
    @Test
    public void cadastroDeCiclo() {
        cicloPage = new CicloPage();
        cicloFlows = new CicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        cicloFlows.navegateTelaCiclo();
        cicloPage.adicionarCiclo();
        cicloPage.verificarCicloAdicionado();
        cicloPage.editarNomeCiclo();
        cicloPage.adicionarPadraoCiclo();
        cicloPage.tentarExcluirPadraoCicloComRegFilho();
        cicloPage.ativarOpcaoPrimeiroTipPratPadrCiclo();
        cicloPage.adicionarEEditarComplemento();
        cicloPage.excluirTipoPratoPadrCiclo();
        cicloPage.excluirCicloAdicionado();

        try {
            Thread.sleep(7000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }

    //veificar os campos obrigatórios (código e nome) do formulário de adicionar ciclo
    //tentar excluir o primeiro ciclo que possuí registros filhos. Isso não deve ser permitido
    //adicionar um ciclo, verificar se por padrão o mesmo vem com a opção 'Ativo' selecionada
    //editar o ciclo e desmarcar a opção 'Ativo' e verificar se após salvar a opção não está mais selecionada
    //excluir o ciclo adicionado
    //tentar adicionar ciclo com código já cadastrado e verificar a mensagem que é exibida na tela
    @Test
    public void verificacaoDosCamposEValidacoes() {
        cicloPage = new CicloPage();
        cicloFlows = new CicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        cicloFlows.navegateTelaCiclo();
        cicloPage.campoObrigatoriosFormAddCiclo();
        cicloPage.tentarExcluirCicloComRegFilho();
        cicloPage.adicionarCiclo();
        cicloPage.verificarOpcaoAtivoCiclo();
        cicloPage.excluirCicloAdicionado();
        cicloPage.tentarAddCicloCodRepetido();

        try {
            Thread.sleep(7000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }


}
